Subject: bug#78976: 2 bugs in eintr

From: Eli Zaretskii <[email-masked]>
Date: Sat, 19 Jul 2025 10:46:43 +0300

> Date: Tue, 08 Jul 2025 14:37:08 +0000
> From: "Иван Битюцкий" <[email-masked]>
> Cc: [email-masked]
> 
> Greetings!
> I've found 2 bugs in "Emacs Lisp Intro", which is
> "An Introduction to Programming in Emacs Lisp"
> by Bob Chassell.
> ***
> 1st bug: When reading in Emacs in info and evaluating code
> from Appendix C "A graph with labeled axes" with C-x C-e,
> then switching to scratch buffer to print the graph, Emacs
> complains about wrong number of arguments to a function
> print-Y-axis .
> ***
> 2nd bug: Appendix C "A graph with labeled axes" , function
> print-X-axis-numbered-line does not print the first number
> in the X axis of the graph.
> ***
> I've fixed both bugs and the fixed functions are in attached
> file eintr-bugfix.el.gz

Thanks.  However, I couldn't figure out what code specifically you are
talking about.  Appendix C has quite a lot of code, with some
functions presented more than once, as the development of their code
proceeds.  I need specific pointers to problematic code, preferably in
terms of line numbers in the source file emacs-lisp-intro.texi.  The
code you present is also quite different from what the manual presents
as the "final versions" of the functions in section C.4 and its
subs-sections.  So I had difficulty understanding what to change and
where.

> ***
> Suggestion: Add another page with final versions of all
> functions to print graph put together, so readers can
> install them with C-x C-e, then switch to the scratch
> buffer and print the graph. I've collected all the necessary
> functions with bugfixes and a small extra function to make
> it easier to print graph in attached file eintr-graph.el.gz

This is okay, but your suggested code includes more than just the
functions and the variables needed to build graphs: it also includes
some graph data.  These should be clearly separated, for obvious
didactic reasons.

> ***
> Other:  At the end of Index node, when I press SPACE,
> I'm taken to "C.2.1 Side Trip: Compute a Remainder"
> instead of "About the Author" node.

Pressing SPC at the end of a node with a menu (which is what the Index
node is: a giant menu) should take you to the node pointed to by the
first menu item.  In my case, the first menu item is this:

  * .emacs file:                           Emacs Initialization. (line   6)

And indeed, pressing SPC takes me to the "Emacs Initialization" node.
So I see no problem here, and don't understand why you expected to be
taken to "C.2.1" subsection.